import csv
import matplotlib.pyplot as plt
from math import sqrt

def importFichier(fichier):
    """
    Entrée : string -> nom du fichier à importer (avec extension)
    Sortie : liste de liste contenant les éléments du fichier csv SANS la première ligne du fichier
    """
    donnee=open(..., encoding='utf8')
    liste=list(csv.reader(donnee,delimiter=","))
    liste.pop(...)
    return(...)

def distance(point1,point2):
    """ renvoie la distance les points point1(longP1,largP1) et point2(longP2,largP2) """







    return dist


def Insertion(liste,Elt):
    """ Algorithme d'insertion dans une liste triée. Ajoute Elt en fin de liste avant de le faire "remonter" à la bonne position.
    liste doit être triée dans l'ordre croissant.
    Elt est un couple (distance,variete).sans utiliser la méthode sort()
    EXEMPLE :  Insertion([(1.2, 'setosa'), (2, 'setosa'), (2.3, 'virginica')],(1.5, 'versicolor') ) -> [(1.2, 'setosa'), (1.5, 'versicolor'), (2, 'setosa'), (2.3, 'virginica')]"""









    return liste


def compteVarietes(listeVoisins):
    """ Parcours la liste listeVoisins contenant des couples (distance,variete).
    Distance est un nombre flottant et variete une chaine de caractère.
    Cette fonction compte le nombre de fleurs de chaque variété dans la liste et renvoie un dictionnaire de clefs les variétés.
    Exemple :
    >>> compteVarietes([(1.2, 'setosa'), (1.5, 'versicolor'), (2, 'setosa'), (2.3, 'virginica')])
    {'setosa': 2, 'versicolor': 1, 'virginica': 1}"""












    return (nbVarietes)

def maxFleurs(dico):
    """Exemple : maxFleurs({'setosa': 2, 'versicolor': 1, 'virginica': 1})->
'setosa'"""











            return variete
### CI-DESSOUS NE PAS MODIFIER
def afficheFleurs(Fleurs, longSup = [], largSup = []):
    """ Permet d'afficher les fleurs passées en paramètre sous forme d'une liste nommée ici Fleurs.
    Ce sont les fleurs du fichier iris.csv donc chaque élément de la liste est une liste de taille 5 (long sépale, larg sépale, long pétale, larg pétale, variété).
    Les fleurs sont représentées par un point dans un repère d'abscisses la longueur des pétales et d'ordonnées leur largeur. Iris setosa en rouge, versicolor en vert et virginica en bleu.
    Les deux paramètres facultatifs longSup largSup permettent de passer une fleur supplémentaire dont on voudrait étudier la variété, elle sera alors représentée par un point noir.
    Ex : >>> afficheFleurs(importFichier('iris.csv'),2.6,0.7)"""
    # On parcourt la liste des fleurs
    for fleur in Fleurs:
        x = float(fleur[2]) # 3ème élément -> longueur d'un pétale -> abscisse
        y = float(fleur[3]) # 4ème élément -> largeur d'un pétale  -> ordonnée
        variete = fleur[4]  # 5ème élément -> variété de l'iris    -> couleur
        if variete == "setosa":
            couleur = 'r'
        elif variete == "versicolor":
            couleur = 'g'
        elif variete == "virginica":
            couleur = 'b'
        plt.scatter(x,y,color = couleur) # On place le point dans un repère

    # Point supplémentaire en noir, correspondant à la fleur étudiée
    if longSup != []:
        plt.scatter(longSup,largSup,color = 'black', label='Iris inconnu') # On place le point dans un repère
    # Création de la légende, étape facultative
    for var in [('setosa','r'),('versicolor','g'),('virginica','b')]:
        plt.scatter([],[], color = var[1], label = var[0])
    plt.legend()
    plt.ylabel("largeur d'un pétale (cm)")
    plt.xlabel("longueur d'un pétale (cm)")
    plt.show() # On affiche la figure (plt.save(...) permet de la sauvegarder).

def classeFleur(longueurP,largeurP,nbVoisins = 3):
    """ Fonction utilisant l'algorithme des k plus proches voisins pour déterminer la variété d'un iris dont on passe la ongueur et la largeur du pétale en paramètres.
    nbVoisins est le nombre de voisins à utiliser dans l'algorithme, par défaut 3.
    >>> classeFleur(2.6,0.7)
    Voici les 3 plus proches voisins : {'versicolor': 2, 'setosa': 1}
    'versicolor'
    >>> classeFleur(5.4,1.6,6)
    Voici les 6 plus proches voisins : {'virginica': 5, 'versicolor': 1}
    'virginica'
    """
    # import du fichier iris.csv sous forme de liste
    Fleurs = importFichier('iris.csv')

    # Parcours de toutes les fleurs pour calculer la distance et sauvegarde des nbVoisins plus proches (ordre croissant)
    listeVoisins = [] # liste de couples (distance, variété) contenant les nbVoisins plus proches voisins
    for fleur in Fleurs:
        # Calcul de la distance au carré (pour ne pas avoir de racine carrée)
        d = distance((longueurP,largeurP),(float(fleur[2]),float(fleur[3])))
        variete = fleur[4]
        # si on a moins de nbVoisins fleurs, on ajoute la fleur actuelle dans la liste des voisins et on classe (tri par insertion)
        if len(listeVoisins) < nbVoisins:
            listeVoisins = Insertion(listeVoisins,(d,variete))
        # sinon on compare la distance actuelle avec la plus grande chez les voisins
        else:
            # si la distance est plus courte, on ajoute la fleur actuelle en fin de liste et on classe (tri par insertion)
            if d < listeVoisins[len(listeVoisins)-1][0]:
                listeVoisins.pop()  # on enlève le dernier élément (pour en conserver nbVoisins)
                listeVoisins = Insertion(listeVoisins,(d,variete))  # on ajoute le nouvel élément au bon endroit

    # Création d'un dictionnaire répertoriant le nombre de fleurs de chaque variété chez les voisins
    nbVarietes = compteVarietes(listeVoisins)
    print('Voici les',len(listeVoisins),'plus proches voisins :',nbVarietes)

    # Parcours du dictionnaire pour identifier la variete la plus présente
    variete = maxFleurs(nbVarietes)

    return variete